//+------------------------------------------------------------------+
//|                                        PraticeTakeProfitonBB.mq4 |
//|                               Copyright 2015, FerrariGreenAssocs |
//|                                     http://www.Ferrari-Green.com |
//+------------------------------------------------------------------+
#property copyright "Click Here to Learn More About Mql4 Programming"
#property link      "http://www.jimdandymql4courses.com"
#property version   "10.0"
#property description "This is an example of how to use the description lines."
#property description "This is being taught in the first video of level 4."
#property description "Click the link to learn more!"
#property strict
#include <stderror.mqh>
#include <stdlib.mqh>
//--- input parameters
extern double StopLoss=20;
input double   LotSize=0.01;

//---
extern int Slippage=30;
extern int MagicNumber=1234;

double pips;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
// Determine what a pip is.
   pips =Point; //.00001 or .0001. .001 .01.
   if(Digits==3||Digits==5)
   pips*=10;
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment(" ");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   CheckForSignal();
   TakeProfit();
   {
   double ma_20_price =iMA(Symbol(),PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE,0));
   } 
if  (Price==ma_20_price) //--- round about of course


   
  }

//+------------------------------------------------------------------+
//|       TRIGGER FUNCTION                                           |
//+------------------------------------------------------------------+
void CheckForSignal(){
   static datetime candletime = 0;
   if(candletime != Time[0]){
      double UpperBB=iBands(NULL,0,20,2,0,PRICE_TYPICAL,MODE_UPPER,1);
      double LowerBB= iBands(NULL,0,20,2,0,PRICE_TYPICAL,MODE_LOWER,1);
      double RSI= iRSI(NULL,0,14,PRICE_TYPICAL,1);
      double ADX= iADX(NULL,0,7,PRICE_TYPICAL,MODE_MAIN,1);
      double Price=(Close[1]+Open[1]+High[1]+Low[1])/4;
      if(Price<LowerBB && RSI>30 && ADX<32)
         EnterTrade(OP_BUY);
      else if(Price>UpperBB && RSI<70 && ADX<32)
         EnterTrade(OP_SELL);
      candletime=Time[0];
   }
}
//+------------------------------------------------------------------+
//|     TRADE PLACING FUNCTION                                       |
//+------------------------------------------------------------------+
void EnterTrade(int type){

   int err=0;
   double price=Bid, sl=0, tp=0;
   if(type == OP_BUY)
      price =Ask;
   //----
   int ticket =  OrderSend(Symbol(),type,LotSize,price,Slippage,0,0,"MAEA Trade",MagicNumber,0,Magenta); 
   if(ticket>0){
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         sl = OrderOpenPrice()+(StopLoss*pips);
         tp = OrderOpenPrice()-(TakeProfit*pips);
         if(OrderType()==OP_BUY)
         {
            sl = OrderOpenPrice()-(StopLoss*pips);
            tp = OrderOpenPrice()+(TakeProfit*pips);
         }
         if(!OrderModify(ticket,price,sl,tp,0,Magenta)) {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
      }
      else{//in case it fails to select the order for some reason 
         Print("Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else{//in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placement!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}